################## MANDELBROTOVA MNOZINA ##################
import numpy as np                # import balicku
import matplotlib.pyplot as plt   # import balicku

##################  Volitelne parametry ##################
max_it        = 150         # maximalni pocet iteraci
x_min, x_max  = -2.0, 0.6   # zobrazeny rozsah hodnot v realne ose
y_min, y_max  = -1.2, 1.2   # zobrazeny rozsah hodnot v imaginarni ose
rozl_x        = 1000        # pocer bodu na realnou osu
rozl_y        = 1000        # pocet bodu na imaginarni osu
m             = 4           # parametr funkce
barva         = "RdPu"      # nastaveni barevneho spektra ("hsv", "cool", "viridis" aj. ...)
plt.axis("off")             # vypnuti/zapnuti os
plt.grid("off")             # vypnuti/zapnuti mrizky

################## Pomocna nastaveni ##################
zobr_oblast = [x_min, x_max, y_min, y_max]  # nastaveni zobrazovane oblasti
plt.xlabel('Re')
plt.ylabel('Im')

################## Definice funkce pocitajici hodnoty Mandelbrotovy mnoziny #################
def Mandelbrot(rozl_y, rozl_x, x_min, x_max, y_min, y_max, m, max_it):
  MM = np.full([rozl_y, rozl_x],0)
  X = np.linspace(x_min, x_max, num = rozl_x)
  Y = np.linspace(y_min, y_max, num = rozl_y)
  for y_index, y in enumerate(Y):
    for x_index, x in enumerate(X):
      i = 0
      c = complex (x, y)
      z = 0
      while (abs(z)) <= m and i < max_it:
        z = z**2 + c        # vypocet hodnoty mnoziny
        i += 1
      MM[rozl_y-1-y_index, x_index] = 255-i # prirazeni iterace
  return MM  

################## Vykresleni Mandelbrotovy mnoziny ##################
Mandelbrot_data = Mandelbrot(rozl_y, rozl_x, x_min, x_max, y_min, y_max, m, max_it) # volani funkce Mandelbrot
plt.imshow(Mandelbrot_data , cmap = barva, extent = zobr_oblast) # tvorba obrazku
plt.show()  # zobrazeni Mandelbrotovy mnoziny


